# This spec file was generated using Kpp, then edited by hand

# This is a spec-file for Mandrake distribution. I have no idea if it works with others

%define _name kmuddy
%define _version 0.8
%define _release 1
%define _packager Tomas Mecir <kmuddy@kmuddy.net>
%define _distribution SuSE Linux 10.1
%define _prefix /opt/kde3

Summary:   MUD client for KDE3
Name:      %{_name}
Version:   %{_version}
Release:   %{_release}
Copyright: GPL
Vendor:    Tomas Mecir <kmuddy@kmuddy.net>
Url:      http://www.kmuddy.net/
Packager:  %{_packager}
Group:     Networking/Games
Source:    %{_name}-%{_version}.tar.gz
BuildRoot: /tmp/%{_name}-%{_version}
Distribution: %{_distribution}
Prefix: %{_prefix}

%description
KMuddy is an extensible  MUD client for KDE3. Features include:
- MUD output displayer with complete ANSI color support
- MCCP (MUD compression protocol) support
- MSP (MUD Sound Protocol) support
- MXP (MUD eXtension Protocol) support
- multiple connections within one instance
- configurable colors, short-cuts, ...
- split screen when viewing output history
- command history
- connection profiles
- quick connect
- auto connect
- configurable login sequence
- multi-line input
- word wrapping and indentation
- connection timer
- aliases (with regex support)
- triggers (with regex support)
- color triggers
- gagging support
- test area for aliases and triggers
- alias/trigger groups
- internal scripting
- external scripting
- timers
- variables
- gauges
- macro keys
- profile settings
- plug-in support
- session transcript in multiple formats
- speed-walking
- action toolbar
... and more

%prep
%setup
KDEDIR=%{prefix}
LOCALFLAGS="--enable-final --with-sdl"
./configure --prefix %{prefix} $LOCALFLAGS
%build
# Setup for parallel builds
numprocs=`egrep -c ^cpu[0-9]+ /proc/stat || :`
if [ "$numprocs" = "0" ]; then
  numprocs=1
fi

make -j$numprocs

%install
make install DESTDIR=$RPM_BUILD_ROOT

cd $RPM_BUILD_ROOT
find . -type d | sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > $RPM_BUILD_DIR/file.list.%{_name}.in
find . -type f | sed 's,^\.,\%attr(-\,root\,root) ,' >> $RPM_BUILD_DIR/file.list.%{_name}.in
find . -type l | sed 's,^\.,\%attr(-\,root\,root) ,' >> $RPM_BUILD_DIR/file.list.%{_name}.in
sed s/kmuddy\.1/kmuddy.1.gz/ < $RPM_BUILD_DIR/file.list.%{_name}.in > $RPM_BUILD_DIR/file.list.%{_name}

%clean
rm -rf $RPM_BUILD_ROOT/*
rm -rf $RPM_BUILD_DIR/%{_name}-%{version}
rm -rf ../file.list.%{_name}

# update-menus stuff was copied from one mdk specfile

%post
#SDL needs timidity patches in /usr/local/lib/timidity in order to play
#.mid files; these may already be installed in /usr/lib/timitidy; if this
#is the case, we create a symlink
if [ -f /usr/share/timidity/timidity.cfg ]
  then ln -s /usr/share/timidity /usr/local/lib/timidity
fi

%files -f ../file.list.%{_name}
