//
// C++ Implementation: cgaugebar
//
// Description: 
//
//
// Author: Tomas Mecir <kmuddy@kmuddy.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "cgaugebar.h"

#include "cgauge.h"
#include "cgaugebaritem.h"
#include "cgaugelist.h"

#include <qlayout.h>
#include <qobjectlist.h>

cGaugeBar::cGaugeBar (int sess, QWidget *parent, const char *name)
 : QWidget(parent, name), cActionBase ("gaugebar", sess)
{
  layout = new QHBoxLayout (this);
  layout->setSpacing (5);
  setFixedHeight (16);
  setSizePolicy (QSizePolicy::Fixed, QSizePolicy::Expanding);
  setFocusPolicy (QWidget::NoFocus);
}


cGaugeBar::~cGaugeBar ()
{
}

void cGaugeBar::rebuild (cGaugeList *gauges)
{
  //remove current children from the layout
  const QObjectList *list = children();

  QObjectListIterator it (*list);
  QObject *obj = 0;
  while ((obj = it.current()) != 0)
  {
    layout->remove ((QWidget *) *it);
    ++it;
  }

  //then add new ones in the correct order
  for (gauges->reset(); *gauges; (*gauges)++)
  {
    cGauge *gauge = (cGauge *) **gauges;
    cGaugeBarItem *item = gauge->gaugeItem();
    layout->addWidget (item);
  }
}


#include "cgaugebar.moc"
