//
// C++ Interface: cgaugelist
//
// Description: 
//
//
// Author: Tomas Mecir <kmuddy@kmuddy.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef CGAUGELIST_H
#define CGAUGELIST_H

#include "csaveablelist.h"

#include <qcolor.h>
#include <qstring.h>

class cGauge;

/**
List of gauges.

@author Tomas Mecir
*/
class cGaugeList : public cSaveableList
{
Q_OBJECT
public:
  cGaugeList (QString filename, int sess);
  ~cGaugeList ();

  /** a gauge request, adds a new gauge, if there is no gauge already using the
  same base variable */
  bool requestGauge (const QString &var, const QString &maxvar, const QString &caption,
      const QColor &color, bool hidden);
  /** as above; *DELETES* the gauge if it can't accept it! */
  bool requestGauge (cGauge *gauge);
  
  void gaugesChanged ();
 protected:
  virtual void eventHandler (QString event, int session,
      QString &par1, const QString &par2);
  /** handle the fact that a variable value has been changed */
  void variableChanged (const QString &varname, const QString &value);
  /** function not valid here, so it's overriden to prevent problems */
  void setEnabled (bool) {};
  /** abstract & not needed*/
  virtual void processCommands (const QStringList &) {};
};

#endif  //CGAUGELIST_H
