//
// C++ Interface: cSessionManager
//
// Description: Session manager.
//
//
// Author: Tomas Mecir <kmuddy@kmuddy.net>, (C) 2002-2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef CSESSIONMANAGER_H
#define CSESSIONMANAGER_H

struct cSessionManagerPrivate;
class cTabBar;
class QWidgetStack;

#include <qstring.h>

#define MAXSESSIONS 50

/**
This class manages the open sessions.

@author Tomas Mecir
*/
class cSessionManager {
public:
  /** returns pointer to instance */
  static cSessionManager *self();
  /** destructor */
  ~cSessionManager ();

  /** session count */
  int count ();
  
  int getSessionByTab (int tabnumber);
  int addSession (bool profile = true);
  bool removeSession (int which, bool dontClose = false);
  void setSession (int which);
  int activeSession ();
  bool isProfileSession (int sess);
  void setSessionName (int which, QString name, bool defName = true);
  void changeSession (int id);
  
  void setWidgetStack (QWidgetStack *stack);
  void setTabBar (cTabBar *tabbar);
  
  /** should the tab bar be displayed even if there is only one connection? */
  bool alwaysTabBar ();
  void setAlwaysTabBar (bool value);

  /** set notify flag for the given tab */
  void setNotifyFlag (int sess);

private:
  /** constructor */
  cSessionManager ();
  static cSessionManager *_self;
  cSessionManagerPrivate *d;
};

#endif
