//
// C++ Interface: cstatusvarlist
//
// Description: 
//
//
// Author: Tomas Mecir <kmuddy@kmuddy.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef CSTATUSVARLIST_H
#define CSTATUSVARLIST_H

#include "csaveablelist.h"

class cStatusVar;

/**
This class holds a list of status vars.

@author Tomas Mecir
*/
class cStatusVarList : public cSaveableList
{
Q_OBJECT
 public:
  cStatusVarList (QString filename, int sess);
  ~cStatusVarList ();
  
  /** a status-var request, adds a new status-var, if there is no status var already using the
  same base variable */
  bool requestStatusVar (const QString &var, const QString &maxvar, const QString &caption,
      bool percentage, bool hidden);
  /** as above; *DELETES* the status var if it can't accept it! */
  bool requestStatusVar (cStatusVar *sv);

 public slots:
  void varTextChanged ();
 protected:
  virtual void eventHandler (QString event, int session,
      QString &par1, const QString &par2);
  void variableChanged (const QString &varname, const QString &varvalue);
  /** function not valid here, so it's overriden to prevent problems */
  void setEnabled (bool) {};
  /** abstract & not needed*/
  virtual void processCommands (const QStringList &) {};
};

#endif
