//
// C++ Interface: dlgstatusvars
//
// Description: Status variables dialog box
//
//
// Author: Tomas Mecir <kmuddy@kmuddy.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef DLGSTATUSVARS_H
#define DLGSTATUSVARS_H

#include <kdialogbase.h>

class cStatusVarList;

class KListBox;
class KPushButton;

/**
Dialog used to edit the list of status variables.

@author Tomas Mecir
*/
class dlgStatusVars : public KDialogBase
{
Q_OBJECT
public:
  dlgStatusVars (cStatusVarList *svlist, QWidget *parent = 0, const char *name = 0);

  ~dlgStatusVars ();
protected slots:
  void add ();
  void modify ();
  void remove ();
  void up ();
  void down ();
protected:
  void createDialog ();

  void updateMe ();

  cStatusVarList *svl;
  
  KListBox *box;
  KPushButton *btadd, *btmodify, *btdelete, *btup, *btdown;
};

#endif
