/***************************************************************************
                        dlgtimertick.h  -  description
                             -------------------
    begin                : Wed 11.2.2004
    copyright            : (C) 2004 by Marco Mastroddi
    email                : marco.mastroddi@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef DLGTIMERTICK_H
#define DLGTIMERTICK_H

/**
Tick timer dialog.
  *@author Marco Mastroddi
  */

#include <qvariant.h>
#include <qdialog.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QPushButton;
class QCheckBox;
class QFrame;
class QLabel;
class QLineEdit;
class QSpinBox;
class cTimerTick;

class dlgTimerTick : public QDialog
{
  Q_OBJECT

public:
  dlgTimerTick( cTimerTick*, QWidget* parent = 0, const char* name = 0 );
  ~dlgTimerTick();

protected:
  QPushButton* bOk;
  QPushButton* bCancel;
  QCheckBox* cbEnableTickTimer;
  QFrame* frameTick;
  QLabel* label3;
  QLineEdit* leCommand;
  QLabel* label2;
  QSpinBox* sbTimeoutMargin;
  QSpinBox* sbTickInterval;
  QLabel* label1;

protected:
  void updateMenu();

protected slots:
  virtual void languageChange();
  void slotOk();
  void slotCancel();
  void somethingChanged();

private:
  cTimerTick *timerTick;
  QGridLayout* dlgTimerTickLayout;
  QGridLayout* frameTickLayout;
  bool resetTickTimer;

};

#endif // DLGTIMERTICK_H
