/***************************************************************************
                          cvariable.cpp  -  one variable
                          ------------------------------
    begin                : Po sep 8 2003
    copyright            : (C) 2003 by Tomas Mecir
    email                : kmuddy@kmuddy.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cvariable.h"
#include "cvalue.h"

#include <kconfig.h>

cVariable::cVariable ()
{
  _name = QString::null;
  val = 0;
}

cVariable::~cVariable ()
{
  delete val;
}

cSaveableField *cVariable::newInstance ()
{
  return new cVariable;
}

void cVariable::load (KConfig *config, const QString &group)
{
  config->setGroup (group);
  setName (config->readEntry ("Name", QString::null));
  setValue (cValue::load (config));
}

void cVariable::save (KConfig *config, const QString &group)
{
  config->setGroup (group);
  config->writeEntry ("Name", _name);
  if (val)
    val->save (config);
  else {
    // just so it won't crash or keep old data, if we have no value ...
    config->writeEntry ("Type", 0);
    config->writeEntry ("Value", "");
  }
}

QString cVariable::value ()
{
  if (val) return val->asString ();
  return QString::null;
}

void cVariable::setValue (const QString &newvalue)
{
  cValue *oldv = val;
  val = new cValue (newvalue);
  delete oldv;
}

void cVariable::setValue (const cValue *v)
{
  cValue *oldv = val;
  val = new cValue (*v);
  delete oldv;
}

