/***************************************************************************
                          dlgscripts.h  -  Scripts dialog
                             -------------------
    begin                : Ne dec 22 2002
    copyright            : (C) 2002 by Tomas Mecir
    email                : kmuddy@kmuddy.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DLGSCRIPTS_H
#define DLGSCRIPTS_H

#include <qwidget.h>
#include <kdialogbase.h>

class cScriptList;

class KListBox;
class KPushButton;

/**
This dialog shows a list of defined scripts.
  *@author Tomas Mecir
  */

class dlgScripts : public KDialogBase  {
   Q_OBJECT
public: 
  dlgScripts (cScriptList *slist, QWidget *parent=0, const char *name=0);
  ~dlgScripts ();
protected slots:
  void add ();
  void modify ();
  void remove ();
  void run ();
  void up ();
  void down ();
  void up10 ();
  void down10 ();
  void moveto ();
  void changePositionInfo (int newpos);
  void sort ();
protected:
  void createDialog ();

  void updateMe ();

  cScriptList *list;

  KListBox *box;
  KPushButton *btadd, *btmodify, *btdelete, *btrun;
  KPushButton *btup, *btdown, *btsort;
  KPushButton *bt10up, *bt10down, *btmoveto;
  QLabel *lblcurpos;
};

#endif
