//
// C++ Implementation: testplugin
//
// Description: Testing plugin.
//
//
// Author: Tomas Mecir <kmuddy@kmuddy.net>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include "testplugin.h"

#include <kgenericfactory.h>
#include <kdebug.h>

typedef KGenericFactory<cTestPlugin> cTestPluginFactory;
K_EXPORT_COMPONENT_FACTORY (kmuddytestplugin, cTestPluginFactory("kmuddy"))

cTestPlugin::cTestPlugin (QObject *, const char *, const QStringList &)
{
  setInstance (cTestPluginFactory::instance());
  
  // your code here ...
  kdDebug() << "Testing plugin loaded." << endl;
}

cTestPlugin::~cTestPlugin()
{
  // your code here ...
  kdDebug() << "Testing plugin unloaded." << endl;
}


void cTestPlugin::sessionAdd (int sess, bool fresh)
{
  kdDebug() << "Testing plugin: sessionAdd " << sess << ", " << (fresh?"fresh":"not fresh") << endl;
}

void cTestPlugin::sessionRemove (int sess, bool closed)
{
  kdDebug() << "Testing plugin: sessionRemoved " << sess << ", " << (closed?"closed":"not closed") << endl;
}

void cTestPlugin::sessionSwitch (int sess)
{
  kdDebug() << "Testing plugin: sessionSwitch " << sess << endl;
}

void cTestPlugin::connected (int sess)
{
  kdDebug() << "Testing plugin: connected " << sess << endl;
}

void cTestPlugin::disconnected (int sess)
{
  kdDebug() << "Testing plugin: disconnected " << sess << endl;

}

void cTestPlugin::rawData (int sess, char * data)
{
  static bool first = false;
  if (!first)
    kdDebug() << "Testing plugin: rawData " << sess << " (first call)" << endl;
  first = true;
}

void cTestPlugin::decompressedData (int sess, char * data)
{
  static bool first = false;
  if (!first)
    kdDebug() << "Testing plugin: decompressedData " << sess << " (first call)" << endl;
  first = true;
}

void cTestPlugin::processInput (int sess, int phase, cTextChunk * chunk,
    bool gagged)
{
  static bool first = false;
  if (!first)
    kdDebug() << "Testing plugin: processInput " << sess << " (first call)" << endl;
  first = true;
}

void cTestPlugin::processPrompt (int sess, cTextChunk * chunk)
{
  static bool first = false;
  if (!first)
    kdDebug() << "Testing plugin: processPrompt " << sess << " (first call)" << endl;
  first = true;
}

void cTestPlugin::processCommand (int sess, QString & command, bool & dontSend)
{
  static bool first = false;
  if (!first)
    kdDebug() << "Testing plugin: processCommand " << sess << " (first call)" << endl;
  first = true;
}




